/**
 * @file	queue.c
 * @author	myusgun <myusgun@gmail.com>
 */
#include "cf_queue.h"
#include "cf_debug.h"

int main (void)
{
	long long int	iter = 0;
	int				result = 0;
	long long int	element = 0;
	CF_Queue_Ctx	ctx = NULL;

	// create
	result = CF_Queue_CreateCtx (&ctx);
	if (result < 0)
		CF_DEBUG_PRINT (stderr, "error %d\n", result);

	// insert
	for (iter = 0 ; iter < 10 ; iter++)
	{
		result = CF_Queue_Put (ctx, (void *)iter);
		if (result < 0)
			CF_DEBUG_PRINT (stderr, "error %d\n", result);
	}

	// move next
	for (iter = 0 ; iter < 10 ; iter++)
	{
		result = CF_Queue_Front (ctx, (void **)&element);
		if (result < 0)
			CF_DEBUG_PRINT (stderr, "error %d\n", result);
		else
			CF_DEBUG_PRINT (stderr, "front : %4d\n", element);

		result = CF_Queue_Get (ctx, (void **)&element);
		if (result < 0)
			CF_DEBUG_PRINT (stderr, "error %d\n", result);
		else
			CF_DEBUG_PRINT (stderr, "got   : %4d\n", element);

		CF_DEBUG_PRINT (stderr, "\n");
	}

	// destroy
	result = CF_Queue_DestroyCtx (ctx);
	if (result < 0)
		CF_DEBUG_PRINT (stderr, "error %d\n", result);

	return 0;
}
